Package: segtools
Type: Package
Title: What the package does (short line)
Version: 1.0
Date: 2012-06-27
Author: Who wrote it
Maintainer: Who to complain to <yourfault@somewhere.net>
Description: More about what it does (maybe more than one line)
License: What license is it under?

==========
 segtools
==========
by Michael Hoffman <mmh1@washington.edu>
and Orion Buske <orion.buske@gmail.com>


Description
===========
DESCRIPTION


Prerequisites
=============
- Python_ 2.5.1
- HDF5_ 1.8.2
- PyTables 2.1.1 (from source)
- R 2.7 (configured with --enable-R-shlib)
- NumPy 1.2.1
- zlib
- szip (if installing HDF5 from binaries)

.. _HDF5: http://www.hdfgroup.org/
.. _PyTables: http://www.pytables.org/download/stable/tables-2.1.1.tar.gz
.. _NumPy: http://numpy.scipy.org/
.. _zlib: http://www.hdfgroup.org/HDF5/release/obtain5.html
.. _szip: http://www.hdfgroup.org/HDF5/release/obtain5.html

Automatically installed
-----------------------
- Setuptools 0.6c9
- path.py
- textinput
- rpy2


Installation
============
For a detailed walk-through, see the ``INSTALL'' file.

Once all prerequisites have been installed, segtools (and other
prerequisites) will be installed with:

    python setup.py install

If R is not installed, or plotting is not desired, call the validator
with the --noplot flag.


Running
=======
Installing segtools creates a number of command-line entry points to 
run the modules in the python package. These commands are placed in 
~/bin, so you may want to add ~/bin to your PATH for your convenience:

   seg-validate
   seg-validate-feature-aggregation
   seg-validate-label-transition
   seg-validate-length-distribution
   seg-validate-nucleotide-frequency
   seg-validate-signal-distribution
   seg-validate-transition-matrix
   seg-validate-tss-overlap

All the above commands are equipped with -h/--help options for usage 
information.

License
=======
This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

seg-validate is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

This is the source for Segtools as an R package in its own right,
rather than as R scripts called from Python/rpy2. The R scripts should
be identical--R/segtools/R is just a symlink to segtools/R.

Run ./build.sh to generate the package tarball.

Then you can install in R with install.packages("segtools_1.0.tar.gz", repos = NULL)

From then on, only library(segtools) is necessary in your R scripts.

library(plyr)
library(reshape)
library(RColorBrewer)
library(lattice)
library(latticeExtra)

read.nuc <- function(filename = "nucleotide.tab", mnemonics = NULL, ...,
                     check.names = FALSE)
{
  res <- read.delim(filename, ..., check.names = check.names)
  res$label <- factor(res$label)

  if (length(mnemonics) > 0) {
    res$label <- relabel.factor(res$label, mnemonics)
  } else {
    res$label <- smart.factor.reorder(res$label)
  }

  res
}

normalize.dinuc <- function(data) {
  data.df <- data.frame(data, check.names = FALSE)
  dinuc <- subset(data.df, select = -c(`?`, `??`, `A|T`, `C|G`))

  # Compensate for symmetric dinucleotide
  dinuc$`AT|AT` <- 2*dinuc$AT
  dinuc$`CG|CG` <- 2*dinuc$CG
  dinuc$`GC|GC` <- 2*dinuc$GC
  dinuc$`TA|TA` <- 2*dinuc$TA
  dinuc <- subset(dinuc, select = -c(AT, CG, GC, TA))

  # Normalize each row to one
  label.col <- match("label", colnames(dinuc))
  dinuc.nolabel <- dinuc[, -label.col]
  dinuc[, -label.col] <- dinuc.nolabel / rowSums(dinuc.nolabel)

  # order columns
  dinuc[,c(label.col, order(colnames(dinuc)[-label.col]) + 1)]
}

levelplot.dinuc <-
  function(x = value ~ variable + label,
           data, 
           ..., 
           deselect = c("C|G", "A|T", "?", "??"),
           aspect = "fill",
           palette = colorRampPalette(rev(brewer.pal(11, "RdYlBu")),
             interpolate = "spline", space = "Lab")(100))
{
  data.melted <- melt(data, id.vars="label")
  data.subset <- subset(data.melted, !variable %in% deselect)

  # Reverse label ordering for plotting
  data.subset$label <- factor(data.subset$label, 
                              levels=rev(levels(data.subset$label)))

  levelplot(x = x,
            data = data.subset,
            aspect = aspect,
            cuts = 99,
            col.regions = palette,
            xlab = "Dinucleotide",
            ylab = "Segment label")
}

plot.dinuc <- function(tabfile, mnemonics=NULL) {
  nucs <- read.nuc(tabfile, mnemonics=mnemonics)
  dinuc <- normalize.dinuc(nucs)

  levelplot.dinuc(data = dinuc)
}

library(RColorBrewer)
library(lattice)
library(latticeExtra)
library(plyr)
library(reshape)

############### OVERLAP ANALYSIS ##############

read.overlap <- function(filename, mnemonics = NULL, col_mnemonics = NULL,
                         ..., check.names = FALSE, colClasses = "character",
                         comment.char = "#")
{
  res <- read.delim(filename, ..., check.names = check.names,
                    colClasses = colClasses, comment.char = comment.char)

  # Substitute colnames and reorder cols (except first and last two)
  set.cols <- c(1, ncol(res) - 1, ncol(res))
  colname.map <- map.mnemonics(colnames(res)[-set.cols], col_mnemonics)
  colnames(res) <- c("label", colname.map$labels,
                     colnames(res)[set.cols[-1]])
  res <- res[, c(set.cols[1], colname.map$order + 1, set.cols[-1])]

  # Substitute rownames and reorder rows
  label.map <- map.mnemonics(res$label, mnemonics)
  res$label <- label.map$labels
  res <- res[label.map$order,]
  
  if (ncol(res) == 2) {
    res[, 2] <- as.numeric(res[, 2])
  } else{
    res[, 2:ncol(res)] <- apply(res[, 2:ncol(res)], 2, as.numeric)
  }
  
  metadata <- read.metadata(filename, comment.char = comment.char)

  list(data = res, metadata = metadata)
}

# Given a list of labels, returns a list of colors to give those labels
label.colors <-
  function(labels)
{
  # Determine label groups
  labels <- labels.classify(labels)
  label.groups <- unique(labels$group)

  # Assign a different color to each group
  color.groups <- rainbow(length(label.groups))
  label.colors <- vector(mode = "character", length = nrow(labels))
  
  for (i in 1:length(label.groups)) {
    # Adjust color darker for each increasing number in same group
    label.group <- subset(labels, group == label.groups[i])
    group.ordered <- label.group[order(label.group$index),]

    # Transpose and scale to 0-1 for rgb()
    color.group <- t(col2rgb(color.groups[i]) / 255)
    group.size <- nrow(label.group)
    for (j in 1:group.size) {
      # Subtrack up to 1/3
      color.rgb <- color.group * (1 - 0.33 * (j - 1) / group.size)
      color.rgb[color.rgb < 0] <- 0
      color <- rgb(red = color.rgb[1], 
                   green = color.rgb[2], 
                   blue = color.rgb[3])

      # Insert color back in at appropriate point in color vector
      label <- group.ordered[j,]
      label.index <- (labels$group == label$group &
                      labels$index == label$index)
      label.colors[label.index] <- color
    }
  }

  label.colors
}

panel.overlap <-
  function(x, y, groups, subscripts, labels, colors,
           plot.text = TRUE, plot.points = TRUE, cumulative = TRUE, ...)
{
  if (plot.points) {
    panel.xyplot(x, y, pch = 20, col = "black",
                 subscripts = subscripts, ...)
  }

  if (plot.text) {
    if (plot.points) {
      adj <- c(-0.25, -0.25)
    } else {
      adj <- NULL
    }
    labels <- as.character(labels)
    if (cumulative) {
      ## Prepend a "+" to all but the first label
      x.ord <- order(x)
      indices <- x.ord[2:length(x.ord)]
      labels[indices] <- paste("+", labels[indices], sep = "")
    }
    panel.text(x, y, 
               labels = labels,
               col = colors,
               adj = adj,
               #cex = c(0.2, 0.9),
               ...)
  }
}

# Returns a data table of tp/fp/fn for the given counts
overlap.stats <- function(counts, cumulative = TRUE) {
  labels <- counts$label
  total.counts <- counts$total
  none.counts <- counts$none
  feature.counts <- subset(counts, select = -c(label, total, none))
  feature.sums <- colSums(feature.counts)
#  total.sum <- sum(as.numeric(total.counts))

  tp <- feature.counts
  fp <- total.counts - feature.counts
  fn <- t(feature.sums - t(feature.counts))
#  tn <- total.sum - total.counts - fn

  if (cumulative) {
    precision <- tp / (tp + fp)
    ## Replace columns with cumulative data (sorted by precision)
    for (col.i in 1:ncol(precision)) {
      label.ord <- order(precision[, col.i], decreasing = TRUE)
      ## Calculate cumulative statistics
      total.cum <- cumsum(total.counts[label.ord])
      tp.cum <- cumsum(feature.counts[label.ord, col.i])
      fp.cum <- total.cum - tp.cum
      fn.cum <- feature.sums[col.i] - tp.cum
      tp[label.ord, col.i] <- tp.cum
      fp[label.ord, col.i] <- fp.cum
      fn[label.ord, col.i] <- fn.cum
    }
  }
  
  res <- list(label = labels,
              tp = tp,
              fp = fp,
              fn = fn)
                     
  res
}

# Returns a data frame of p/r for the given counts
pr.stats <- function(data, ...) {
  stats <- overlap.stats(data$data, ...)

  precision <- suppressMessages(melt(with(stats, tp / (tp + fp))))
  recall <- suppressMessages(melt(with(stats, tp / (tp + fn))))

  res <- data.frame(label = stats$label, group = precision$variable,
                    precision = precision$value, recall = recall$value)
  
  list(data = res, metadata = data$metadata)
}

# Write an overlap data frame to a file
write.stats <- function(stats, namebase, dirpath = ".", clobber = FALSE) {
  data <- stats$data
  tabfilename <- extpaste(namebase, "tab")
  tabfilepath <- file.path(dirpath, tabfilename)

  if (file.exists(tabfilepath) && !clobber) {
    stop("Found stats table: ", tabfilepath,
         ". Use --clobber to overwrite!", sep = "")
  }
  row.ord = order(data$group, data$precision, decreasing = TRUE)
  data.formatted <- format(data[row.ord,], digits = 3)
  write.table(data.formatted, tabfilepath, quote = FALSE,
              sep = "\t", row.names = FALSE)
}

xyplot.overlap <-
  function(overlap.data = NULL,
           data = overlap.data$data,
           metadata = overlap.data$metadata,
           mode = metadata$mode,
           x = precision ~ recall | group, 
           small.cex = 1.0,
           large.cex = 1.0,
           as.table = TRUE,
           auto.key = FALSE, #list(space = "right"),
           xlab = list("Recall (TP / (TP + FN))", cex = large.cex),
           ylab = list("Precision (TP / (TP + FP))", cex = large.cex),
           cumulative = TRUE,
           sub = if (cumulative) "Cumulative P-R (left-to-right, by precision)"
                 else NULL,
           x.lim = c(0, 1),
           y.lim = NULL,
           scales = list(cex = small.cex,
             x = list(limits = x.lim),
             y = list(limits = y.lim)),
           panel = panel.overlap,
           labels = data$label,
           colors = label.colors(labels),
           par.strip.text = list(cex = small.cex),
           ...)
{
  if (mode != "bases") {
    warning("P-R performance plot only mathematically valid for base-overlap")
  }
  if (is.null(y.lim)) {
    y.max <- max(data$precision)
    y.lim <-
      if (y.max >= 0.5) {
        c(0, 1)
      } else {
        c(0, y.max * 1.05)
      }
  }
  
  xyplot(x, data, groups = label,
         as.table = as.table, 
         auto.key = auto.key,
         xlab = xlab,
         ylab = ylab,
         sub = sub,
         scales = scales,
         cumulative = cumulative,
         panel = panel,
         labels = labels,
         colors = colors,
         par.strip.text = par.strip.text,
         ...)
}

plot.overlap.performance <-  function(tabfile, mnemonics = NULL,
                                      col_mnemonics = NULL,
                                      cumulative = TRUE,
                                      comment.char = "#", ...) {
  ## Plot the predictive ability of each segment label for each feature class
  ##   in PR space
  ##
  ## tabfile: a tab file containing overlap data with segment labels on the rows
  ##   and feature classes on the columns and the overlap "count" at the
  ##   intersection. Row and columns should have labels.
  
  data <- read.overlap(tabfile, mnemonics = mnemonics,
                       col_mnemonics = col_mnemonics,
                       comment.char = comment.char)
  stats <- pr.stats(data, cumulative = cumulative)
  
  xyplot.overlap(stats, cumulative = cumulative, ...)
}

save.overlap.performance <- function(dirpath, namebase, tabfilename,
                                     mnemonic_file = NULL,
                                     col_mnemonic_file = NULL,
                                     clobber = FALSE,
                                     cumulative = TRUE,
                                     panel.size = 300,  # px
                                     comment.char = "#",
                                     ...) {
  mnemonics <- read.mnemonics(mnemonic_file)
  col.mnemonics <- read.mnemonics(col_mnemonic_file)
  data <- read.overlap(tabfilename, mnemonics = mnemonics,
                       col_mnemonics = col.mnemonics,
                       comment.char = comment.char)
  stats <- pr.stats(data, cumulative = cumulative)
  write.stats(stats, namebase, dirpath, clobber = clobber)
  
  panels.sqrt <- max(c(sqrt(nlevels(stats$data$group)), 1))
  width <- 100 + panel.size * ceiling(panels.sqrt)
  height <- 200 + panel.size * floor(panels.sqrt)
  save.images(dirpath, namebase,
              xyplot.overlap(stats, cumulative = cumulative, ...),
              width = width,
              height = height,
              clobber = clobber)
}

############### OVERLAP HEATMAP ############

levelplot.overlap <- function(overlap.data = NULL,
                              data = overlap.data$data,
                              metadata = overlap.data$metadata,
                              mode = metadata[["mode"]],
                              row.normalize = TRUE,
                              y.mode = if (row.normalize) "Fraction"
                                       else "Count",
                              sub = paste(y.mode, "of", mode, "in subject",
                                "label that overlap at least one in query",
                                "label"),
                              xlab = "label in query file",
                              ylab = "label in subject file",
                              none.col = TRUE,  # Include 'none' column
                              cluster = FALSE,  # Cluster both dimensions
                              cluster.rows = cluster,
                              cluster.cols = cluster,
                              num.colors = 100,
                              aspect = "fill",
                              max.contrast = FALSE,  # Saturate color range
                              col.range = if (max.contrast) NULL else c(0, 1),
                              scales = list(x = list(rot = 90)),
                              palette = colorRampPalette(
                                rev(brewer.pal(11, "RdYlBu")),
                                interpolate = "spline",
                                space = "Lab")(num.colors),
                              cuts = num.colors - 1,
                              ...)
{
  ## Create a levelplot showing overlap proportions
  ##
  ## data: data frame with subject labels on rows, query labels on cols, and
  ##   proportion of coverage at intersection
  ## mode: "segments", "bases" or whatever the units of overlap are
  ## col.range: NULL sets the colorscale to the range of the data, else
  ##   it should be a vector or list of two integers which specify the
  ##   lower and upper bounds of the color scale. Overrides max.contrast

  if (is.null(mode)) stop("Overlap file missing 'mode' metadata.")
  
  ## Convert to matrix
  mat <- subset(data, select = -c(label, total))
  mat.nonone <- subset(mat, select = -c(none))
  if (!none.col) {
    mat <- mat.nonone
  }
  mat <- as.matrix(mat)
  if (row.normalize) {
    mat <- mat / data$total
  }
  rownames(mat) <- data$label
  
  ## Order rows and columns
  row.ord <- nrow(mat.nonone):1
  col.ord <- 1:ncol(mat.nonone)
  
  ## Cluster, holding out none col
  ## This "clustering", or more appropiately, reording of rows and columns
  ## to increase density along the diagonal is done using multidimensional
  ## scaling techniques to find a linear order. This MDS approach to
  ## ordering a matrix is discussed in the "seriation" package, under
  ## the seriate.dist documentation.
  if (cluster.rows) {
    row.ord <- order(cmdscale(dist(mat.nonone), k = 1))
  }
  if (cluster.cols) {
    col.ord <- rev(order(cmdscale(dist(t(mat.nonone)), k = 1)))
  }
  if (none.col) {  # Re-add none col to end
    col.ord <- c(col.ord, length(col.ord) + 1)
  }
  
  if (is.null(col.range)) {
    col.range <- range(mat)
  } else if (length(col.range) != 2) {
    stop("Invalid value of col.range")
  }

  colorkey.at <- seq(col.range[[1]], col.range[[2]], length = num.colors - 1)
  levelplot(t(mat[row.ord, col.ord]),
            sub = sub,
            xlab = xlab,
            ylab = ylab,
            cuts = cuts,
            scales = scales,
            aspect = aspect,
            at = colorkey.at,
            col.regions = palette,
            ...)
}

plot.overlap.heatmap <- function(filename, mnemonics = NULL,
                                 col_mnemonics = NULL,
                                 comment.char = "#",
                                 ...) {
  ## Plot a heatmap from overlap data
  ##
  ## filename: overlap table file
  ## mnemonics, col_mnemonics: mnemonic list (as per read.mnemonics)
  
  data <- read.overlap(filename, mnemonics = mnemonics,
                       col_mnemonics = col_mnemonics,
                       comment.char = comment.char)

  levelplot.overlap(data, ...)
}

save.overlap.heatmap <- function(dirpath, namebase, tabfilename,
                                 mnemonic_file = NULL,
                                 col_mnemonic_file = NULL,
                                 clobber = FALSE,
                                 max_contrast = FALSE,
                                 panel.size = 30,  # px
                                 comment.char = "#",
                                 ...) {
  mnemonics <- read.mnemonics(mnemonic_file)
  col.mnemonics <- read.mnemonics(col_mnemonic_file)
  data <- read.overlap(tabfilename, mnemonics = mnemonics,
                       col_mnemonics = col.mnemonics,
                       comment.char = comment.char)

  height <- 400 + panel.size * nrow(data$data)
  width <- 400 + panel.size * ncol(data$data)
  save.images(dirpath, namebase,
              levelplot.overlap(data, ..., max.contrast = max_contrast),
              height = height,
              width = width,
              clobber = clobber)
}

read.length <- function(filename, mnemonics = NULL, ...) {
  filename <- as.character(filename)
  if (!file.exists(filename)) {
    stop(paste("Error: missing length file:", filename))
  }
  res <- read.delim(filename, ...)

  res$label <- relevel.mnemonics(factor(res$label), mnemonics)

  # Reverse rows for plot
  res$label <- factor(res$label, levels = rev(levels(res$label)))

  res
}

expected.len <- function(prob.loop) {
  prob.loop / (1 - prob.loop)
}

panel.violinplot <-
  function(x, y, ..., box.ratio, mark.prior = NULL,
           marks.posterior = NULL, rug = FALSE, do.out = FALSE)
{
  if (!is.null(mark.prior)) {
    log10.mark.prior <- log10(mark.prior)
    panel.refline(v = log10.mark.prior, h = 0)
  }

  # In order to do a violin-plot, each label must have at least
  # two data points. Ignore any labels with fewer data points.
  keep_levels <- c()
  for (lev in levels(y)) {
    if (sum(y == lev) > 1) {
      # Keep entries for level if enough data points
      keep_levels <- c(keep_levels, lev)
    }
  }
  keep <- is.element(y, keep_levels)
  x <- x[keep]
  y <- y[keep]
  
  # Violin-plot of non-unique label entries
  panel.violin(x, y, ..., box.ratio = box.ratio)

  # Only display most extreme points
  panel.bwplot(x, y, ..., box.ratio = 0, do.out = FALSE)
  plot.symbol <- trellis.par.get("plot.symbol")
  fontsize.points <- trellis.par.get("fontsize")$points
  for (i in 1:nlevels(y)) {
    subset = (y == levels(y)[i])
    x.out <- range(x[subset], finite = TRUE)
    panel.points(x.out, i, pch = plot.symbol$pch, col = plot.symbol$col,
                 alpha = plot.symbol$alpha, cex = plot.symbol$cex,
                 fontfamily = plot.symbol$fontfamily,
                 fontface = plot.symbol$fontface,
                 fontsize = fontsize.points, ...)
  }
  
  # Add remaining plots
  if (rug) {
    panel.rug(x[keep], NULL, ..., end = 0.01)
  }
  if (!is.null(marks.posterior)) {
    log10.marks.posterior <- log10(marks.posterior)
    panel.points(log10.marks.posterior, seq_along(marks.posterior),
                 pch = "|", col = "black", cex = 3)
  }
}

# data: a data.frame with a row for each segment
#   label: (factor) the segment label
#   length: (integer) the length of the segment
# mnemonics: a matrix where [,1] is old labels and [,2] is new labels
violinplot.length <-
  function(data, 
           x = label ~ length,
           nint = 100,
           xlab = "Length", ylab = "Label",
           scales = list(x = list(log = TRUE,
                                  at = at.log(),
                                  labels = labels.log() )),
           panel = panel.violinplot, 
           expected.lens = NULL,
           ...)
{
  marks.posterior <-
    if (is.null(expected.lens)) {
      NULL
    } else {
      expected.len(expected.lens)
    }

  bwplot(x, data, nint = nint, 
         xlab = xlab, ylab = ylab,
         scales = scales, 
         panel = panel,
         marks.posterior = marks.posterior,
         ...)
}

plot.length <- function(filename, mnemonics = NULL, ...) {
  data <- read.length(filename, mnemonics = mnemonics)
  violinplot.length(data = data, ...)
}

save.length <- function(dirpath, namebase, tabfilename,
                        mnemonic_file = NULL,
                        clobber = FALSE,
                        label.height = 35,
                        image.width = 600,
                        ...) {
  mnemonics <- read.mnemonics(mnemonic_file)
  data <- read.length(tabfilename, mnemonics = mnemonics)

  save.images(dirpath, namebase,
              violinplot.length(data = data, ...),
              height = label.height * nlevels(data$label) + 75,
              width = image.width,
              clobber = clobber)
}


############### SEGMENT SIZES ###############

read.segment.sizes <-
  function(filename, mnemonics = NULL, ..., check.names = FALSE)
{
  res.all <- read.delim(filename, ..., check.names = check.names)

  res <- res.all[res.all$label != "all",]

  res$label <- relevel.mnemonics(factor(res$label), mnemonics)
  
  res$frac.segs <- res$num.segs / sum(res$num.segs)

  res
}

panel.segment.sizes <- 
  function(...)
{
  panel.barchart(..., origin = 0)
}

barchart.segment.sizes <- 
  function(data, 
           x = reorder(label, -frac.bp) ~ frac.bp + frac.segs,
           main = NULL, #"Segment sizes",
           show_bases = TRUE,
           show_segments = TRUE,
           xlab = "Fraction of segmentation",
           ylab = "Segment label",
           panel = panel.segment.sizes,
           as.table = TRUE,
           xlim = c(0, max.frac),
           col = c("red", "blue"),
           auto.key = list(space = "top", 
                           columns = 2, 
                           text = c("Bases", "Segments"),
                           rectangles = TRUE,
                           points = FALSE),
           par.settings = list(superpose.polygon = list(col = col)),
           ...)
{
  max.data <- max(c(data$frac.bp, data$frac.segs))
  if (show_bases & !show_segments) {
    delayedAssign("x", reorder(label, -frac.bp) ~ frac.bp)
    auto.key$columns <- 1
    auto.key$text <- auto.key$text[1]
    col <- c(col[1])
    max.data <- max(data$frac.bp)
  } else if (show_segments & !show_bases) {
    delayedAssign("x", reorder(label, -frac.segs) ~ frac.segs)
    auto.key$columns <- 2
    auto.key$text <- auto.key$text[2]
    col <- c(col[2])
    max.data <- max(data$frac.segs)
  } else if (!show_segments & !show_bases) {
    stop("Expected either/both show_bases or show_segments")
  }

  max.frac <- min(c(1, 1.05 * max.data))

  barchart(x = x, 
           data = data,
           main = main,
           xlab = xlab, 
           ylab = ylab,
           panel = panel,
           as.table = as.table,
           xlim = xlim,
           col = col,
           auto.key = auto.key,
           par.settings = par.settings,
           ...)
}

plot.segment.sizes <- function(filename, ...) {
  data <- read.segment.sizes(filename)
  barchart.segment.sizes(data = data, ...)
}

save.segment.sizes <- function(dirpath, namebase, tabfilename,
                               clobber = FALSE, mnemonic_file = NULL,
                               height = 600, width = 800,
                               ...) {
  mnemonics <- read.mnemonics(mnemonic_file)
  data <- read.segment.sizes(tabfilename, mnemonics = mnemonics)
  save.images(dirpath, namebase,
              barchart.segment.sizes(data = data, ...),
              height = height,
              width = width,
              clobber = clobber)
}
  

read.distances <-
  function(filename, mnemonics = NULL, ..., check.names = FALSE)
{
  res <- read.delim(filename, ..., check.names = check.names)
  res$label <- relevel.mnemonics(factor(res$label), mnemonics)
  res
}

panel.distances <-
  function(...)
{
  panel.barchart(..., origin = 0)
}

figure.distances <- 
  function(data, 
           x = count ~ distance | label,
           xlab = "Distance from feature (0 if overlapping)",
           ylab = "Number of segments",
           panel = panel.distances,
           col = "blue",
           auto.key = as.logical(nlevels(data$group) > 1),
           label.count = 11,
           ...)
{
  layout <- c(1, nlevels(data$label))
  distance.vals <- sort(unique(data$distance))
  
  finite.distances <- data$distance[is.finite(distance.vals)]
  distance.max <- max(finite.distances)
  distance.min <- min(finite.distances)
  
  distance.labels <- format(distance.vals, scientific = FALSE)

  distance.labels[distance.vals == Inf] <-
    paste(">", format(distance.max, scientific = FALSE))
  distance.labels[distance.vals == -Inf] <-
    paste("<", format(distance.min, scientific = FALSE))
  keep.label.indices <-
    if (distance.min == 0) {
      seq(1, length(distance.labels), length.out=label.count)
    } else {
      zero.index <- which(distance.vals == 0)
      c(seq(1, zero.index, length.out=as.integer(label.count / 2 + 1)),
        tail(seq(zero.index, length(distance.labels),
                 length.out=as.integer(label.count / 2 + 1)), -1))
    }


  keep.labels <- vector(mode = "logical", length = length(distance.labels))
  keep.labels[keep.label.indices] <- TRUE
  distance.labels[!keep.labels] <- ""
  
  # Replace infinities with bounded vals so everything sorts correctly
  data$distance[data$distance == Inf] <- distance.max + 1
  data$distance[data$distance == -Inf] <- distance.min - 1
  barchart(x = x, 
           data = data,
           group = group,
           xlab = xlab, 
           ylab = ylab,
           panel = panel,
           col = col,
           auto.key = auto.key,
           horizontal = FALSE,
           stack = TRUE,
           layout = layout,
           scales = list(x = list(rot = 90, labels=distance.labels)),
           ...)
}

plot.distances <- function(filename, ...) {
  data <- read.distances(filename)
  figure.distances(data = data, ...)
}

save.distances <- function(dirpath, namebase, tabfilename,
                           clobber = FALSE, mnemonic_file = NULL,
                           height = 200 * rows, width = 600,
                           ...) {
  mnemonics <- read.mnemonics(mnemonic_file)
  data <- read.distances(tabfilename, mnemonics = mnemonics)
  rows <- nlevels(data$label)
  height <- 200 * rows
  save.images(dirpath, namebase,
              figure.distances(data = data, ...),
              height = height,
              width = width,
              clobber = clobber)
}
  

## requires common.R
## requires track_statistics.R

library(plyr)
library(reshape)
library(cluster)
library(lattice)
library(RColorBrewer)
library(latticeExtra)

## Relabel and reorder matrix row/colnames with mnemonics
relabel.matrix <- function(mat, mnemonics = NULL, 
                           relabel.cols = TRUE, relabel.rows = TRUE)
{
  ## Start with default names
  rownames(mat) <- as.character(0:(nrow(mat)-1))
  colnames(mat) <- as.character(0:(ncol(mat)-1))
  row.ord <- 1:nrow(mat)
  col.ord <- 1:ncol(mat)
  if (relabel.rows) {
    label.map <- map.mnemonics(rownames(mat), mnemonics)
    rownames(mat) <- label.map$labels
    row.ord <- label.map$order
  }
  if (relabel.cols) {
    label.map <- map.mnemonics(colnames(mat), mnemonics)
    colnames(mat) <- label.map$labels
    col.ord <- label.map$order
  }
  
  mat[row.ord, col.ord]
}

read.transition <- function(filename, mnemonics = NULL, ...)
{
  res <- read.matrix(filename)
  res.labeled <-  relabel.matrix(res, mnemonics = mnemonics)

  res.labeled
}

read.gmtk.transition <- function(filename, mnemonics = NULL, ...)
{
  lines <- readLines(filename)

  start <- grep("^seg_seg", lines) + 3
  con <- textConnection(lines[start - 1])
  dims <- as.numeric(scan(con, what = "numeric", n = 2, quiet = TRUE))
  close(con)
  end <- start + dims[1] - 1

  con <- textConnection(lines[start:end])
  res <- read.table(con)
  close(con)
  res.labeled <- relabel.matrix(res, mnemonics = mnemonics)

  res.labeled
}


matrix.find_quantile <- function(x, q)
{
  v = as.vector(x)
  quantile(x, q, names=FALSE)
}

matrix.asymmetry <- function(x)
{
  x[x < 1e-5] = 0  # Threshold low values
  x = x/t(x)
  x[!is.finite(x)] = 0  # Kill weird areas
  x = log2(x)
  x[!is.finite(x)] = 0  # Kill weird areas
  x[abs(x) < 0.5] = 0  # Threshold low values

  x
}

## Generates levelplot of data in given file
## Returns data used to generate plot
## mnemonics: an array where [,1] is old labels and [,2] is new labels
levelplot.transition <-
  function(data,
           ddgram = FALSE, 
           asymmetry = FALSE,
           aspect = "iso",
           scales = list(x = list(rot = 90)),
           legend = if (ddgram) ddgram.legend(dd.row, dd.col, row.ord, col.ord)
                    else list(),
           palette = colorRampPalette(rev(brewer.pal(9, "PiYG")),
             interpolate = "spline", 
             space = "Lab")(100),
           ...)
{
  ## Looking at reciprocal probabilities for this run
  if (asymmetry) {
    data <- matrix.asymmetry(data)
  }
  
  if (ddgram) {
    dd.row <- as.dendrogram(hclust(dist(data)))
    row.ord <- order.dendrogram(dd.row)
    dd.col <- as.dendrogram(hclust(dist(t(data))))
    col.ord <- order.dendrogram(dd.col)
  } else {
    row.ord <- nrow(data):1
    col.ord <- 1:ncol(data)
  }
  
  colorkey <-
    if (ddgram) {
      list(space = "left")
    } else {
      list(space = "right")
    }
  
  par(oma=c(1, 1, 1, 1))  # Add a margin
  levelplot(t(data[row.ord, col.ord, drop = FALSE]),
            aspect = aspect,
            scales = scales,
            xlab = "End label", 
            ylab = "Start label",
            cuts = 99,
            col.regions = palette,
            colorkey = colorkey,
            legend = legend,
            ...)
}

plot.transition <- function(filename, mnemonics = NULL, gmtk = FALSE, ...) {
  read.func <- if (gmtk) read.gmtk.transition else read.transition
  data <- read.func(filename, mnemonics = mnemonics)

  levelplot.transition(data, ...)
}

save.transition <- function(dirpath, namebase, filename,
                            mnemonic_file = NULL,
                            clobber = FALSE,
                            image.size = 600, ...) {
  mnemonics <- read.mnemonics(mnemonic_file)
  save.images(dirpath, namebase,
              plot.transition(filename, mnemonics = mnemonics, ...),
              height = image.size,
              width = image.size,
              clobber = clobber)
}

# requires common.R

library(lattice)
library(latticeExtra)
library(grid)

read.signal <- function(filename, mnemonics = NULL, comment.char = "#", ...,
                        colClasses = list(label = "character")) {
  comment.lines <- read.comment.lines(filename, comment.char = comment.char)
  res <- read.delim(filename, ..., colClasses = colClasses)
  res$label <- relevel.mnemonics(factor(res$label), mnemonics)

  res
}

panel.histogram.ecdf <- function(x, y, ref = FALSE, ...) {
  panel.ecdfplot(y, ref = FALSE, ...)
}

panel.histogram.precomp <- function(x, y, ...) {
  box.width <- diff(x[1:2])
  x <- x + (box.width/2)
  panel.barchart(x, y, box.width = box.width, ...)
}

panel.histogram.normalized <- function(x, y, type = NULL, ...) {
  keep <- (is.finite(y) & y > 0)
  panel.xyplot(x[keep], y[keep], type = c("l", "h"), ...)
}

strip.highlight.segtracks <- function(segtracks, horizontal.outer = FALSE, ...) {
  # Define custom strip function that highlights strips
  # when the trackname is in 'segtracks'
  strip.highlighter <- function(which.given,
                                which.panel,
                                factor.levels,
                                ...,
                                horizontal = NULL,  # Ignore
                                bg = NULL) {

    if (factor.levels[which.panel[which.given]] %in% segtracks) {
      strip.default(which.given = which.given, which.panel = which.panel,
	            factor.levels = factor.levels, ..., 
                    horizontal = horizontal.outer, bg = "yellow")
    } else {
      strip.default(which.given = which.given, which.panel = which.panel,
      		    horizontal = horizontal.outer, 
                    factor.levels = factor.levels, ...)
    }
  }

  strip.highlighter
}

## Generates pretty scales for the data.
## layout is a 2-element vector: c(num_rows, num_cols) for the xyplot
## tolerance - fraction of extreme value allowed to not be included in plot.
panel.scales <- function(data, layout, log.y = TRUE, mode = "histogram",
                         tolerance = 0.05, ...) {

  scale.y = list(log = log.y,
    tck = c(0, 1),
    alternating = c(2, 0))
  
  ## Get the x and y axis limits depending on plot mode
  if (mode == "ecdf") {
    limits.x <- list()
    at.x <- list()
    for (track in levels(data$trackname)) {
      track.subset <- subset(data, trackname == track)
      max.x <- max(track.subset$lower_edge, na.rm = TRUE)
      limits.x <- c(limits.x, list(c(0, max.x)))
      at.x <- c(at.x, at.pretty(from = 0, to = max.x, length = 5, largest = TRUE))
    }

    scale.y$labels <- c("0", "1")
    scale.y$limits <- c(0, 1)
    scale.y$at <- c(0, 1)
    log.y <- FALSE
  } else if (mode == "histogram") {
    limits.x <- list()
    at.x <- list()
    for (track in levels(data$trackname)) {
      track.subset <- subset(data, trackname == track)
      max.x <- max(track.subset$lower_edge, na.rm = TRUE)
      limits.x <- c(limits.x, list(c(0, max.x)))
      at.x <- c(at.x, at.pretty(from = 0, to = max.x, length = 5, largest = TRUE))
    }
    
    max.y <- max(data$count, na.rm = TRUE)
    high.exp <- floor(log10(max.y))
    min.y <- if (log.y) 1 else 0
    at.y <- c(min.y, 10^high.exp)
    
    scale.y$labels <- c(as.character(min.y), label.log(10^high.exp))
    scale.y$limits <- c(head(at.y, n = 1), tail(at.y, n = 1))
    scale.y$at <- at.y
  } else if (mode == "normalized") {
    limits.x <- list()
    at.x <- list()
    for (track in levels(data$trackname)) {
      track.subset <- subset(data, trackname == track)
      count.subset <- subset(track.subset, is.finite(count) & count > 0)
      if (nrow(count.subset) == 0) {
        min.x <- min(track.subset$lower_edge)
        max.x <- max(track.subset$lower_edge)
      } else {
        ##min.y <- quantile(count.subset$count, probs = tolerance, na.rm = TRUE)
        min.y <- max(count.subset$count, na.rm = TRUE) * tolerance
        within.tolerance <- subset(count.subset, count >= min.y)
        min.x <- min(within.tolerance$lower_edge)
        max.x <- max(within.tolerance$lower_edge)
      }
      limits.x <- c(limits.x, list(c(min.x, max.x)))
      at.x.pretty <- unlist(at.pretty(from = min.x, to = max.x, length = 10))
      at.x <- c(at.x, list(c(0, tail(at.x.pretty, n = 1))))
      ## print(paste(max(count.subset$lower_edge), " ---> ", max.x))
    }
    scale.y$log <- FALSE
  }

  scales = list(x = list(relation = "free",  # Allow x axes to vary
                  at = c(rep(list(NULL), layout[2] * (layout[1] - 1)), at.x),
                  limits = limits.x,
                  rot = 90),
    y = scale.y,
    cex = 1,
    ...)
  
  scales
}

sum.nona <- function(..., na.rm = TRUE) {
  sum(..., na.rm = na.rm)
}

# Generates a histogram from the precomputed histogram in 'data'
xyplot.signal <-
  function(data,
           x = count ~ lower_edge | trackname + label,  # formula, explained in the lattice book
                # ~ means "is modeled by", as in y ~ x
                # So count is the y axis,  lower_edge is the x axis
                # | means conditioned on
                # So it makes a plot for every label and trackname
           segtracks = NULL,  # List of tracks in segmentation
           mode = "histogram",  # Mode determines display mode
                                # Choice of histogram, ecdf, normalized
           text.cex = 1,
           par.settings = list(add.text = list(cex = text.cex),
                               layout.heights = list(axis.panel = axis.panel,
                                                     strip = strips.heights),
                               layout.widths = list(strip.left = strips.widths)
                               ),
           xlab = "Signal Value",
           ylab = if (mode == "ecdf") "Empirical cumulative density"
                  else if (mode == "normalized") "Fraction of bases"
                  else if (log.y) "Number of bases (log10)"
                  else "Number of bases",
           log.y = FALSE,
           panel = if (mode == "histogram") panel.histogram.precomp
                   else if (mode == "ecdf") panel.histogram.ecdf
                   else if (mode == "normalized") panel.histogram.normalized
                   else stop(paste("Unrecognized mode: ", mode)),
           strip = strip.custom(horizontal = FALSE),
           strip.left = strip.custom(horizontal = TRUE),
           strip.height = 14,
           strip.width = 3,
           border = "transparent",
           col = trellis.par.get("superpose.symbol")$col[1],
           ...)
{
  # defining a new lattice function: see D. Sarkar, _Lattice:
  # Multivariate Data Visualization with R,_ sec. 14.3.1;
  # https://stat.ethz.ch/pipermail/r-help/2008-December/182370.html

  if (length(segtracks) > 0) {
    # Put all seg tracks on one side
    tracks.levels <- levels(data$trackname)
    tracks.highlight <- tracks.levels %in% segtracks
    tracks.ordered <- c(tracks.levels[tracks.highlight],
                        tracks.levels[ ! tracks.highlight])
    data$trackname <- factor(data$trackname, levels = tracks.ordered)

    # Highlight seg track strips instead
    strip <- strip.highlight.segtracks(segtracks)
  }

  if (mode == "normalized") {
    group.sums <- with(data,
                       aggregate(count, list(trackname, label), sum.nona))$x
    group.size <- with(data,
                       aggregate(count, list(trackname, label), length))$x
    data.divisor <- rep(group.sums, times = group.size)
    zero.out <- cumsum(c(1, group.size[-length(group.size)]))
    data.divisor[zero.out] <- NA
    data$count <- data$count / data.divisor
  }

  # this computes the sum of the counts, for the "all" label
  if (mode == "histogram" || mode == "ecdf") {
    labelsums <- with(data, aggregate(count, list(trackname, lower_edge), sum))
    names(labelsums) <- c("trackname", "lower_edge", "count")
    labelsums$label <- factor("all")
    data.full <- rbind(data, labelsums)
    data.full$label <- relevel(data.full$label, ref = "all") 
  } else {
    data.full <- data
  }

  num_rows <- length(levels(data.full$label))
  num_cols <- length(levels(data.full$trackname))
  layout <- c(num_rows, num_cols)
  # Remove space between panels (where axes were)
  axis.panel <- rep(c(0, 1), c(num_rows - 1, 1))
  # Make strips wider and longer to fit full text
  strips.heights <- rep(c(strip.height, 0), c(1, num_rows - 1))
  strips.widths <- rep(c(strip.width, 0), c(1, num_cols - 1))
  
  scales <- panel.scales(data.full, layout, log.y = log.y, mode = mode)

  trellis <- xyplot(x = x,
                    data = data.full,
                    scales = scales,      
                    as.table = TRUE,
                    xlab = xlab,
                    ylab = ylab,
                    panel = panel,
                    border = border,
                    horizontal = FALSE,
                    col = col,
                    ...)

  trellis.outer <- useOuterStrips(trellis, strip = strip,
                                  strip.left = strip.left)

  update(trellis.outer, par.settings = par.settings, evaluate = FALSE)
}


plot.signal <- function(filename, segtracks = NULL, mnemonics = NULL, ...) {
  data <- read.signal(filename, mnemonics = mnemonics)

  xyplot.signal(data = data, segtrack = segtracks, ...)
}

library(grDevices)
library(lattice)
library(RColorBrewer)
library(latticeExtra)
library(plyr)

# Set default theme
lattice.options(default.theme = "theme.dark2",
                legend.bbox = "full")


# Generate log labels
at.log <- function(low.exp = 0, high.exp = 9) {
  10^seq(from = low.exp, to = high.exp)
}


## Generate axis label list for a reasonable axis
at.pretty <- function(from = 0, to = 10, length = 4,
                      largest = FALSE, trim = TRUE) {
  if (from == to) {
    list(from)
  } else {
    at.seq <- pretty(c(from, to), n = length, min.n = length)
    if (trim) {
      # Trim sequence from 0-end
      trimmer <- if (abs(from) < abs(to)) head else tail
      at.seq <- trimmer(at.seq, n = length)
    }
    trimmer <- if (abs(from) < abs(to)) tail else head
    if (largest) {
      # Get only largest value (by abs)
      trimmer(at.seq, n = 1)
    } else {
      at.seq
    }
  }
}

label.log <- function(x) {
  if (x <= 100) {
    x
  } else {
    label <- substitute(10^X, list(X=log10(x)))
    do.call(expression, list(label))
  }
}

labels.log <- function(...) {
  sapply(at.log(...), label.log)
}

read.mnemonics <- function(filename, stringsAsFactors = NULL,
                           colClasses = NULL, na.strings = NULL,
                           quote = "", comment.char = "#",
                           ...) {
  filename <- as.character(filename)
  if (length(filename) > 0 && nchar(filename) > 0) {
    if (!file.exists(filename)) {
      stop(paste("Error: could not find mnemonic file:", filename))
    }
    read.delim(filename, stringsAsFactors = FALSE, colClasses = "character",
               na.strings = NULL, quote = quote, comment.char = comment.char,
               ...)[, 1:2]
  } else {
    NULL
  }
}

read.metadata <- function(filename, ...) {
  ## Read metadata of the form: # <variable>=<value> <variable>=<value>
  if (!file.exists(filename)) {
    stop(paste("Error reading metadata: file not found:", filename))
  }
  lines <- read.comment.lines(filename, ...)
  metadata <- list()
  for (line in lines) {
    tokens.split <- strsplit(line, "=")
    for (tokens in tokens.split) {
      if (length(tokens) != 2) stop("Error occurred processing file metadata")
      variable <- tokens[1]
      value <- tokens[2]
      metadata[[variable]] <- value
    }
  }
  metadata
}

read.comment.lines <- function(filename, comment.char = "#", ...) {
  ## Comment lines must begin with:
  # ...
  conn <- file(filename, "r")
  lines <- list()
  line <- readLines(conn, n = 1)
  while (length(line) > 0) {
    if (substr(line, 1, 1) == comment.char) {
      lineConn <- textConnection(substr(line, 2, nchar(line)))
      tokens <- scan(lineConn, what = character(0), quiet = TRUE)
      close(lineConn)
      lines[[length(lines) + 1]] <- tokens
      line <- readLines(conn, n = 1)
    } else {
      break
    }
  }
  close(conn)
  lines
}

read.matrix <- function(filename, nrow = NULL, ncol = NULL,
                        comment.char = "#") {
  comment.lines <- read.comment.lines(filename, comment.char = comment.char)
  skip <- length(comment.lines)

  if (is.null(ncol)) {
    ## Read first line to determine number of columns
    first.line <- scan(filename, quiet = TRUE, skip = skip, nlines = 1)
    ncol <- length(first.line)
  }
  if (!is.null(nrow)) {
    n <- as.integer(nrow * ncol)
  } else {
    n <- -1
  }
  ## Read data
  data <- scan(filename, n = n, quiet = TRUE, skip = skip)
  if (is.null(nrow)) {
    n <- length(data)
    nrow <- as.integer(n / ncol)
  }
  matrix(data, nrow, ncol, byrow = TRUE)
}

# Given a list of labels (e.g. levels(data$label)), returns a dataframe
# with group and index fields, corresponding to the character and numeric
# components of each label.
labels.classify <- function(labels) {
  labels.str <- as.character(labels)
  labels.split <- matrix(nrow = length(labels.str), ncol = 2)

  # First, split on "."
  labels.parts <- strsplit(labels.str, ".", fixed = TRUE)

  for (i in 1:length(labels.parts)) {
    label <- labels.parts[[i]]
    if (length(label) > 1) {
      ## Splitting worked!
      labels.split[i, 1:2] <- label[1:2]
    } else {
      ## Splitting didn't work. Try treating like normal mnemonics (e.g. TF0)
      match <- regexpr("^[a-zA-Z]+", label)
      match.len <- attributes(match)$match.length
      if (match.len > 0) {
        labels.split[i, 1] <- substring(label, 1, match.len)
        if (nchar(label) > match.len) {
          labels.split[i, 2] <- substring(label, match.len + 1, nchar(label))
        } else {
          labels.split[i, 2] <- "0"
        }
      } else {
        labels.split[i, 1] <- label
        labels.split[i, 2] <- "0"
      }
    }
  }

  data.frame(group=factor(labels.split[,1]), index=factor(labels.split[,2]),
             stringsAsFactors = FALSE)
}

relevel.mnemonics <- function(labels, mnemonics = NULL) {
  if (!is.factor(labels))
    stop("Expected labels as factor")

  label.map <- map.mnemonics(levels(labels), mnemonics = mnemonics)

  if (length(unique(label.map$labels)) != length(label.map$labels)) {
    stop(paste("Error: mnemonic replacement labels are not unique:",
               paste(sort(label.map$labels), collapse = ", ")))
  }

  levels(labels) <- label.map$labels
  factor(labels, levels(labels)[label.map$order])
}

map.mnemonics <- function(labels, mnemonics = NULL) {
  ## Given a vector of string labels and a mnemonics data.frame,
  ## Returns a list with two elements:
  ##   labels: a vector of new string labels
  ##   order: the order these new string labels should then be arranged in
  labels.raw <- as.character(labels)
  labels.new <- labels.raw
  labels.order <- 1:length(labels)
  if (length(mnemonics) > 0) {
    if (ncol(mnemonics) < 2) stop("Mnemonics should have at least 2 columns")

    ## Order by mnemonics
    mnemonics <- data.frame(old=as.character(mnemonics[,1]),
                            new=as.character(mnemonics[,2]),
                            stringsAsFactors=FALSE)

    ## Map the labels that we can
    mapping.rows <- match(labels.raw, mnemonics$old)
    mapping.valid <- is.finite(mapping.rows)
    labels.mapped <- mnemonics$new[mapping.rows[mapping.valid]]
    labels.new[mapping.valid] <- labels.mapped
    ## Leave the labels we can't

    ## Order the mapped labels
    labels.order[mapping.valid] <- order(mapping.rows[mapping.valid])
  } else {
    mapping.valid <- vector(length = length(labels))
  }

  ## Order the unmapped labels, first numerically
  nmapped <- sum(mapping.valid)
  labels.unmapped <- labels.new[!mapping.valid]
  labels.num <- suppressWarnings(as.numeric(labels.unmapped))
  labels.num.valid <- is.finite(labels.num)
  labels.order[!mapping.valid][labels.num.valid] <-
    order(labels.num[labels.num.valid]) + nmapped
  ## ... then lexicographically
  nmapped <- nmapped + sum(labels.num.valid)
  labels.order[!mapping.valid][!labels.num.valid] <-
    order(labels.unmapped[!labels.num.valid]) + nmapped

  list(labels = labels.new, order = labels.order)
}

## Create a dendrogram legend
ddgram.legend <- function(dd.row = NULL, row.ord = NULL,
                          dd.col = NULL, col.ord = NULL) {
  ## if dd.row or dd.col is NULL, that dendrogram is not drawn
  legend <- list()

  if (!is.null(dd.row)) {
    legend$right <- list(fun = dendrogramGrob,
                         args = list(x = dd.row,
                           ord = row.ord,
                           side = "right",
                           size = 10))
  }
  if (!is.null(dd.col)) {
    legend$top <- list(fun = dendrogramGrob,
                       args = list(x = dd.col,
                         ord = col.ord,
                         side = "top"))
  }

  legend
}

theme.dark2 <- function() {
  brew.dark2.8 <- brewer.pal(8, "Dark2")
  brew.paired.12 <- brewer.pal(12, "Paired")
  brew.paired.light.6 <- brew.paired.12[seq(1, 12, 2)]
  brew.paired.dark.6 <- brew.paired.12[seq(2, 12, 2)]

  res <- col.whitebg()

  res$reference.line$col <- gray(0.7) # 30% grey
  res$axis.line$col <- gray(0.7)
  res$dot.line$col <- gray(0.7)
  res$axis.line$lwd <- 2

  res$superpose.line$col <- brew.dark2.8
  res$superpose.symbol$col <- brew.dark2.8

  res$plot.symbol$col <- brew.dark2.8[1]
  res$plot.line$col <- brew.dark2.8[1]

  res$dot.symbol$col <- brew.dark2.8[1]

  res$box.rectangle$col <- brew.dark2.8[1]
  res$box.umbrella$col <- brew.dark2.8[1]

  res$strip.background$col <- brew.paired.light.6
  res$strip.border$col <- gray(0.7)
  res$strip.border$lty <- 1
  res$strip.border$lwd <- 2

  res$strip.shingle$col <- brew.paired.dark.6

  res
}

theme.slide <- function() {
 res <- theme.dark2()

 additions <-
   list(axis.text.x = list(cex = 1.3),
        axis.text.y = list(cex = 1.3),
        par.main.text = list(cex = 2),
        par.sub.text = list(cex = 2),
        layout.heights = list(axis.top = 1.5, axis.bottom = 1.25),
        layout.widths = list(axis.left = 1.25),
        add.text = list(cex = 1.5),
        par.xlab.text = list(cex = 1.5),
        par.ylab.text = list(cex = 1.5),
        par.zlab.text = list(cex = 1.5))

 modifyList(res, additions)
}

lattice.optionlist.slide <-
 list(layout.heights = list(top.padding = list(x = 0.05, units = "snpc"),
        bottom.padding = list(x = 0.05, units = "snpc")), # strip = list(x = 2, units = "lines")),
      layout.widths = list(left.padding = list(x = 0.05,
                             units = "snpc"),
        right.padding = list(x = 0.05, units = "snpc")),
      default.theme = theme.slide)

extpaste <- function(...) {
  paste(..., sep=".")
}

as.slide <- function(image) {
 update(image,
        lattice.options = lattice.optionlist.slide,
        par.settings = theme.slide())
}

print.image <- function(image, filepath, device, as.slide = FALSE, ...) {
  ## create the filepath's parent directory, if it doesn't already exist
  dir.create(dirname(filepath), showWarnings=FALSE, recursive=TRUE)

  device(filepath, ...)

  if (as.slide) {
    plot(as.slide(image))
  } else {
    plot(image)
  }
  dev.off()

  filepath
}

save.image <- function(image, basename, ext, dirname, device, ..., clobber = FALSE) {
  filename.ext <- extpaste(basename, ext)
  filepath <- file.path(dirname, filename.ext)

  if (!clobber && file.exists(filepath)) {
    cat(paste("Error:", filepath, "already exists.",
              "Image will not be overwritten.",
              "Specify --clobber to overwrite."))
  } else {
    tryCatch(print.image(image, filepath, device, ...),
             error = function(e) {
               cat(paste("Error creating image: ", filepath,
                         ". Error message: ", e$message, "\n", sep = ""))
             })
  }

  filename.ext
}

dev.print.images <- function(basename, dirname, image,
                             width = 800, height = 800,
                             width.slide = 1280, height.slide = 1024,
                             width.pdf = 11, height.pdf = 8.5,
                             device.png = png,
                             device.pdf = pdf,
                             make.png = TRUE,
                             make.slide = TRUE,
                             make.pdf = TRUE,
                             make.thumb = TRUE,
                             pdf.as.slide = TRUE,
                             clobber = FALSE,
                             ...) {
  # No need for PNG plot since it is done python-side
  if (make.png) {
    filename.raster <-
      save.image(image, basename, "png", dirname, device.png,
                 width = width, height = height, units = "px",
                 ..., clobber = clobber)
  }

  if (make.slide) {
    filename.slide <-
      save.image(image, basename, "slide.png", dirname, device.png,
                 width = width.slide, height = height.slide,
                 units = "px", as.slide = TRUE,
                 ..., clobber = clobber)
  }

  if (make.pdf) {
    filename.pdf <-
      save.image(image, basename, "pdf", dirname, device.pdf,
                 width = width.pdf, height = height.pdf,
                 useDingbats = FALSE, as.slide = pdf.as.slide, ...,
                 clobber = clobber)
  }

  if (make.thumb) {
    # Suppress warnings about minimum font size
    filename.thumb <-
      suppressWarnings(
        save.image(image, basename, "thumb.png", dirname, device.png,
                   width = 10, height = 10,
                   units = "in", res = 10, ..., clobber = clobber))
  }
}

save.images <- function(dirpath, basename, image, ..., clobber = FALSE) {
  dev.print.images(basename, dirpath, image, ..., clobber = clobber)
}

library(plyr)
library(reshape)
library(cluster)

COLNAMES <- c("label", "trackname", "mean", "sd")

## File should have fields: label, trackname, mean, sd, ...
read.track.stats <- function(filename, mnemonics = NULL,
                             ...,
                             colClasses = list(label = "factor",
                               trackname = "factor",
                               mean = "numeric",
                               sd = "numeric"))
{
  stats <- read.delim(filename, colClasses = colClasses)
  if (!all(names(stats) == COLNAMES)) {
    stop("Unrecognized track statistic file format")
  }
  stats$label <- relevel.mnemonics(stats$label, mnemonics)
  stats <- rename.tracks(stats, ...)

  stats
}

read.gmtk.track.stats <- function(filename, mnemonics = NULL,
                                  cov = FALSE, ...) {
  means <- parse.gmtk.means(filename)
  covars <- parse.gmtk.covars(filename)
  data <- merge.gmtk.track.stats(means, covars)

  data$label <- relevel.mnemonics(data$label, mnemonics)
  data <- rename.tracks(data, ...)
  data <- covar2sd(data)

  data
}

merge.gmtk.track.stats <- function(means, covars) {
  if (!all(means$trackname[1:nrow(covars)] == covars$trackname)) {
    stop("Track ordering different between means and covars!")
  } else {
    ## Implicit replication across all segs and subsegs
    stats <- subset(means, select=-value)
    stats$mean <- means$value
    stats$covar <- covars$value

    stats
  }
}

is.hierarchical.gmtk <- function(filename) {
  lines <- readLines(filename)
  hierarchical <- length(grep("^seg_subseg $", lines)) > 0

  hierarchical
}

##' returns whether the file is both hierarchical and uses the
##' hierarchy (has more than 1 subseg)
##'
##' <details>
##' @title 
##' @param filename 
##' @return boolean 
##' @author MICHAEL M. HOFFMAN
is.truly.hierarchical.gmtk <- function(filename) {
  lines <- readLines(filename)
  hierarchical <- FALSE

  matches <- grep("^seg_subseg $", lines)

  # in new versions of Segway, subseg is always used, but it has
  # cardinality 1. this assumes a GMTK-generated parameter file
  if (length(matches) > 0) {
    stopifnot(length(matches) == 1)
    if (strsplit(lines[matches[1]+2], " ")[[1]][2] > 1)
      hierarchical <- TRUE
  }

  hierarchical
}

regex.trailing.0 <- "_0$"

##' eliminates trailing _0 if every label ends with that
##'
##' <details>
##' @title simplify.labels
##' @param labels (factor)
##' @return factor
##' @author Michael M. Hoffman
simplify.labels <- function(labels) {
  labels.levels <- levels(labels)

  num.first.subsegs <- sum(grepl(regex.trailing.0, labels.levels))

  # if they all end in _0
  if (length(labels.levels) == num.first.subsegs) {
    levels(labels) <- gsub(regex.trailing.0, "", labels.levels)
  }

  labels
}

parse.gmtk.means <- function(filename, hierarchical =
                             is.hierarchical.gmtk(filename)) {
  ## hierarchical:
  ##   TRUE: parse the params file expecting a hierarchical format
  ##   FALSE: parse the params file as a normal format

  lines <- readLines(filename)

  if (hierarchical) {
    pattern <- "^mean_seg([^_ ]+)_subseg([^_ ]+)_([^ ]+) 1 (.*)"
    replacement <- "\\1_\\2\t\\3\t\\4"
  } else {
    pattern <- "^mean_seg([^_ ]+)_([^ ]+) 1 (.*)"
    replacement <- "\\1\t\\2\t\\3"
  }

  start <- grep("^% means$", lines) + 1
  lines.norm <- lines[start:length(lines)]

  anonfile <- file()
  lines.interesting <-
    lines.norm[grep(pattern, lines.norm)]

  reformulated <- gsub(pattern, replacement, lines.interesting, perl = TRUE)
  writeLines(reformulated, anonfile)

  means <- read.delim(anonfile, header = FALSE,
                      col.names = c("label", "trackname", "value"),
                      colClasses = c("factor", "factor", "numeric"))
  close(anonfile)

  means$label <- simplify.labels(means$label)
  means
}


parse.gmtk.covars <- function(filename) {
  lines <- readLines(filename)
  start <- grep("^% diagonal covariance matrices$", lines) + 1
  lines.norm <- lines[start:length(lines)]

  anonfile <- file()
  lines.interesting <-
    lines.norm[grep("^covar_[^ ]+ 1 .* $", lines.norm)]
  reformulated <- gsub("^covar_([^ ]+) 1 (.*)",
                      "\\1\t\\2", lines.interesting, perl = TRUE)
  writeLines(reformulated, anonfile)

  covars <- read.delim(anonfile, header = FALSE,
                       col.names = c("trackname", "value"),
                       colClasses = c("factor", "numeric"))
  close(anonfile)

  covars
}

## You should probably normalize with normalize.track.stats() before
## calling this.
generate.mnemonics <- function(stats, hierarchical = FALSE, clust.func = hclust, ...) {
  if (!is.array(stats)) {
    stats <- as.stats.array(stats)
  }

  stats.mean <- t(stats[,,"mean"])

  dist.func <- if (hierarchical) hierarchical.dist else dist
  hclust.col <- clust.func(dist.func(stats.mean))

  cut.height <- mean(range(hclust.col$height))
  stems <- (cutree(hclust.col, h = cut.height) - 1)[hclust.col$order]
  stems.reorder <- as.integer(factor(stems, levels = unique(stems))) - 1

  seq.0based <- function(x) {
    seq(0, x - 1)
  }
  stem.starts <- c(0, which(diff(stems.reorder) == 1), length(stems.reorder))
  leaves <- do.call(c, lapply(diff(stem.starts), seq.0based))
  stems.leaves <- paste(stems.reorder, leaves, sep = ".")

  ## Before: hclust.col$labels[hclust.col$order], After: stems.leaves
  mnemonics <- data.frame(old = with(hclust.col, labels[order]),
                          new = stems.leaves, stringsAsFactors = FALSE)
  mnemonics
}

## Can rename tracks according to a regex pattern/replacement
## or a translation table (a Nx2 array, where a trackname found at [i,1]
## are replaced by the string at [i,2])
## If both a translation table and regex replacements are specified, the
## translation table is applied first
rename.tracks <- function(stats, patterns = NULL, replacements = NULL,
                          translation = NULL, ...) {
  if (!is.data.frame(stats)) {
    stop("rename.tracks expected stats as data.frame")
  }

  tracknames <- levels(stats$trackname)
  # Apply translation table substitutions
  if (!is.null(translation)) {
    indices <- match(tracknames, translation[, 1])
    if (any(is.finite(indices))) {
      tracknames[is.finite(indices)] <-
        translation[indices[is.finite(indices)], 2]
    }
  }
  # Apply regex substitutions
  if (!is.null(patterns) || !is.null(replacements)) {
    if (length(patterns) != length(replacements)) {
      stop("Must have an equal number of patterns and replacements")
    }
    for (i in 1:length(patterns)) {
      tracknames <- gsub(patterns[[i]], replacements[[i]], tracknames, perl = TRUE)
    }
  }

  # sometimes replacements can cause the number of unique tracks to change 
  if (length(levels(stats$trackname)) != length(unique(tracknames))) {
    print(levels(stats$trackname))
    print(unique(tracknames))
    stop("length of unique replaced tracknames must be same as length of original tracknames")
  }
  levels(stats$trackname) <- tracknames

  stats
}

as.stats.array <- function(data) {
  if (!is.data.frame(data)) {
    stop("as.stats.array expected data as data.frame")
  }
  data.melted <- melt(data, id.vars = c("label", "trackname"))
  cast(data.melted, trackname ~ label ~ variable)
}

as.stats.data.frame <- function(stats) {
  if (!is.array(data)) {
    stop("as.stats.data.frame expected data as array")
  }
  stats.melted <- melt(stats)
  cast(stats.melted, label + trackname ~ variable)
}

covar2sd <- function(stats) {
  ## Convert covar to sd
  stats$sd <- sqrt(stats$covar)
  stats$covar <- NULL

  stats
}

normalize.track.stats <- function(stats, cov = FALSE, sd.scale = TRUE) {
  if (!is.array(stats)) {
    stop("normalize.track.stats expected stats in array format!")
  }

  ## Normalize mean
  means <- stats[, , "mean"]
  means.range <- t(apply(means, 1, range))
  means.min <- means.range[, 1]
  means.max <- means.range[, 2]
  stats[, , "mean"] <- (means - means.min) / (means.max - means.min)

  if ("sd" %in% dimnames(stats)[[3]]) {
    sds <- stats[, , "sd"]
    if (cov) {  # Make sd into coefficient of variation (capped at 1)
      sds <- sds / rowMeans(means)
      sds[sds > 1] <- 1
    } else {  # Normalize same as mean
      sds <- sds / (means.max - means.min)
      ## If any are over 1, scale all down
      if (sd.scale && any(is.finite(sds)) && any(sds > 1)) {
        sds <- sds / max(sds, na.rm = TRUE)
      }
    }
    stats[, , "sd"] <- sds
  }

  stats
}

normalize.binary.track.stats <- function(stats, cov = FALSE) {
  if (!is.array(stats)) {
    stop("normalize.binary.track.stats expected stats in array format!")
  }
  if (! "sd" %in% dimnames(stats)[[3]]) {
    stop("normalize.binary.track.stats expected standard deviations!")
  }
  ## Compute normalization statistic
  means <- stats[, , "mean"]
  sds <- stats[, , "sd"]
  if (dim(means)[2] != 2) {
    stop("normalize.binary.track.stats expected 2-label segmentation results!")
  }

  means.diff <- apply(means, 1, diff)
  stats[, , "mean"] <- cbind(-means.diff, means.diff) / sds
  stats[, , "sd"] <- NA

  stats
}

hierarchical.dist <- function(mat) {
  ## Returns a distance matrix, accomodating a hierarchical model

  ## Hierarchy is denoted in the rownames, with "a_b" or "a.b"
  ## specifying a's child, b
  ## All nodes of a given level must have the same number of children
  levels.tokens <- strsplit(rownames(mat), "[_.]")
  depth <- length(levels.tokens[[1]])
  for (level.row in levels.tokens) {
    if (length(level.row) != depth) {
      stop("Hierarchy tree does not have a uniform depth")
    }
  }
  if (depth == 1) {
    dist(mat)
  } else {
    ## Convert the list of arrays to a single array,
    ##   since all depths are the same
    levels.mat <- matrix(unlist(levels.tokens), ncol = depth, byrow = TRUE)

    mat.dist <- as.matrix(dist(mat))
    dist.thresh <- max(mat.dist) + 1  # Separate hierarchy levels this far

    for (row.i in 1:nrow(mat)) {
      diff.rows <- rep(FALSE, nrow(mat))
      for (depth.i in 1:(depth - 1)) {
        cur.level <- levels.mat[row.i, depth.i]
        ## Which rows are different at this level
        diff.level <- levels.mat[, depth.i] != cur.level
        ## Add to distance of rows that are different at this level or a
        ##   higher one
        diff.rows <- diff.rows | diff.level
        mat.dist[diff.rows, row.i] <- mat.dist[diff.rows, row.i] + dist.thresh
      }
    }
    as.dist(mat.dist)
  }
}

panel.track.stats <-
  function(x, y, z, subscripts, at = pretty(z), sds = NULL,
           ncolors = 2, threshold = FALSE, sd.shape = "box",
           panel.fill = "mean", box.fill = "gradient",
           sd.box.size = 0.4, sd.scale = 1, sd.line.size = 0.18,
           panel.outline = FALSE, horizontal.sd = TRUE, ...)
{
  require("grid", quietly = TRUE)
  x <- as.numeric(x)[subscripts]
  y <- as.numeric(y)[subscripts]
  z <- as.numeric(z)[subscripts]
  if (is.null(sds)) {
    sds <- 0
  } else {
    sds <- as.numeric(sds)[subscripts]
  }

  z.low <- z - sds
  z.high <- z + sds
  if (threshold) {
    z.low[z.low < 0] <- 0
    z.high[z.high > 1] <- 1
  }

  ##zcol.low <- level.colors(z.low, at = at, ...)
  ##zcol.high <- level.colors(z.high, at = at, ...)
  zcol <- level.colors(z, at = at, ...)
  for (i in seq(along = z))
  {
    if (is.finite(sds[i])) {
      sd.size <- sds[i] * sd.scale
    } else {
      sd.size <- 0
    }
    col.mean <- zcol[i]
    z.range <- seq(from = z.low[i], to = z.high[i], length = ncolors)
    col.gradient <- level.colors(z.range, at = at, ...)

    panel.offsets <- seq(from = - 0.5, by = 1 / ncolors, length = ncolors)
    panel.grad.size <- 1 / ncolors
    box.offsets <- seq(from = - sd.size / 2, by = sd.size / ncolors,
                       length = ncolors)
    box.grad.size <- sd.size / ncolors

    if (horizontal.sd) {
      xs <- x[i] + panel.offsets
      ys <- y[i]
      box.xs <- x[i] + box.offsets
      box.ys <- y[i]
      box.width <- sd.size
      box.height <- sd.box.size
      box.grad.width <- box.grad.size
      box.grad.height <- box.height
      grad.just <- "left"
      panel.grad.width <- panel.grad.size
      panel.grad.height <- 1
      line.width <- sd.size
      line.height <- sd.line.size
    } else {
      xs <- x[i]
      ys <- y[i] + panel.offsets
      box.xs <- x[i]
      box.ys <- y[i] + box.offsets
      box.width <- sd.box.size
      box.height <- sd.size
      box.grad.width <- box.width
      box.grad.height <- box.grad.size
      grad.just <- "bottom"
      panel.grad.width <- 1
      panel.grad.height <- panel.grad.size
      line.width <- sd.line.size
      line.height <- sd.size
    }

    if (panel.fill == "mean") {
      grid.rect(x = x[i], y = y[i], height = 1, width = 1,
                default.units = "native",
                gp = gpar(col = NA, fill = col.mean))
    } else if (panel.fill == "gradient") {
      grid.rect(x = xs, y = ys, height = panel.grad.height,
                width = panel.grad.width,
                just = grad.just, default.units = "native",
                gp = gpar(col = NA, fill = col.gradient))
    }

    if (!is.null(box.fill)) {
      if (box.fill == "mean") {
        grid.rect(x = x[i], y = y[i], height = 1, width = 1,
                  default.units = "native",
                  gp = gpar(col = NA, fill = col.mean))
      } else if (box.fill == "gradient") {
        grid.rect(x = box.xs, y = box.ys, height = box.grad.height,
                  width = box.grad.width, just = grad.just,
                  default.units = "native",
                  gp = gpar(col = NA, fill = col.gradient))
      }
    }

    if (!is.null(sd.shape) && sd.size > 0) {
      if (sd.shape == "box") {
        grid.rect(x = x[i], y = y[i], height = box.height, width = box.width,
                  default.units = "native",
                  gp = gpar(col = "black", fill = NA))
      } else if (sd.shape == "line") {
        grid.rect(x = x[i], y = y[i], height = line.height, width = line.width,
                  default.units = "native",
                  gp = gpar(col = NA, fill = "black"))
      }
    }

    if (panel.outline) {
      grid.rect(x = x[i], y = y[i], height = 1, width = 1,
                default.units = "native",
                gp = gpar(col = "black", fill = NA))
    }

  }
}

levelplot.track.stats <-
  function(stats.obj = NULL,
           track.stats = stats.obj[["stats"]],
           hierarchical = stats.obj[["hierarchical"]],
           axis.cex = 1.0,
           scale.cex = 1.0,
           xlab = list("Segment label", cex = axis.cex),
           ylab = list("Signal track", cex = axis.cex),
           track_order = list(),
           label_order = list(),
           hclust.label = length(label_order) == 0,
           hclust.track = length(track_order) == 0,
           clust.func = hclust,
           aspect = "fill",
           sd.shape = "line",
           box.fill = NULL,
           symmetric = FALSE,
           scales = list(x = list(rot = 90), cex = scale.cex),
           panel = panel.track.stats,
           threshold = FALSE,
           legend = ddgram.legend(dd.row,  row.ord, dd.col,col.ord),
           colorkey = list(space = "left", at = colorkey.at),
           palette = colorRampPalette(rev(brewer.pal(11, "RdYlBu")),
                                      interpolate = "spline",
                                      space = "Lab")(100),
           ...)
{
  if (!is.array(track.stats)) {
    track.stats <- as.stats.array(track.stats)
  }
  if (is.null(hierarchical)) {
    hierarchical <- FALSE
  }

  if (dim(track.stats[, , "mean"])[2] == 2) {
    norm.func <- normalize.binary.track.stats
    symmetric <- TRUE
  } else {
    norm.func <- normalize.track.stats
  }
  stats.norm <- norm.func(track.stats)

  means <- stats.norm[, , "mean"]
  sds <- stats.norm[, , "sd"]

  if (!any(is.finite(means))) {
    warning("No finite mean values found. Nothing to plot!")
    return(NULL)
  } else if (!any(is.finite(sds))) {
    ## Pretent no sds were specified
    sds <- NULL
  }

  mask.rows <- apply(!is.finite(means), 1, any)  # Any row with an NaN
  if (any(mask.rows)) {
    warning("Found infinite or NaN mean values. Ignoring those signal tracks")
    means <- means[!mask.rows,]
    sds <- sds[!mask.rows,]
  }

  if (threshold || is.null(sds) || sd.shape == "line") {
    z.range <- range(means, na.rm = TRUE)
  } else {
    z.range <- c(min(means, means - sds), max(means + sds))
  }

  if (symmetric) {
    z.max <- max(abs(z.range))
    z.range <- c(-z.max, z.max)
  }
  colorkey.at <- seq(from = z.range[1], to = z.range[2], length = 101)

  # Set up dendrogram
  dd.row <- NULL
  dd.col <- NULL
  row.ord <- 1:nrow(means)
  col.ord <- 1:ncol(means)
  if (hclust.track) {
    dd.row <- as.dendrogram(clust.func(dist(means)))
    row.ord <- order.dendrogram(dd.row)
  } else if (length(track_order) > 0) {
    row.ord <- match(track_order, rownames(means))
    stopifnot(row.ord > 0, length(row.ord) == nrow(means))
  }
  if (hclust.label) {
    dist.func <- if (hierarchical) hierarchical.dist else dist
    dd.col <- as.dendrogram(clust.func(dist.func(t(means))))
    col.ord <- order.dendrogram(dd.col)
  } else if (length(label_order) > 0) {
    col.ord <- match(label_order, colnames(means))
    stopifnot(col.ord > 0, length(col.ord) == ncol(means))
  }
  par(oma = c(1, 1, 1, 1))  # Add a margin

  sds.ordered = NULL
  if (! is.null(sds)) {
    sds.ordered = t(sds[row.ord, col.ord])
  }
  levelplot(t(means[row.ord, col.ord, drop = FALSE]),
            sds = sds.ordered,
            aspect = aspect,
            scales = scales,
            panel = panel,
            sd.shape = sd.shape,
            box.fill = box.fill,
            threshold = threshold,
            xlab = xlab,
            ylab = ylab,
            at = colorkey.at,
            col.regions = palette,
            colorkey = colorkey,
            legend = legend,
            ...)
}

load.track.stats <- function(filename, mnemonics = NULL,
                             translations = NULL,
                             as_regex = FALSE,  # Translate with regexs
                             gmtk = FALSE,
                             ...) {
  if (gmtk) {
    read.func <- read.gmtk.track.stats
    hierarchical <- is.truly.hierarchical.gmtk(filename)
  } else {
    read.func <- read.track.stats
    hierarchical <- FALSE
  }

  args <- list(filename, mnemonics = mnemonics, ...)
  if (as_regex) {
    args$patterns <- translations$old
    args$replacements <- translations$new
  } else {
    args$translations <- translations
  }

  stats <- do.call(read.func, args)

  list(stats = stats, hierarchical = hierarchical)
}

plot.track.stats <- function(filename, symmetric = FALSE, ...) {
  res <- load.track.stats(filename, ...)
  levelplot.track.stats(res, symmetric = symmetric, ...)
}

save.track.stats <- function(dirpath, namebase, filename,
                             mnemonic_file = NULL,
                             translation_file = NULL,
                             symmetric = FALSE,
                             clobber = FALSE,
                             square.size = 15,  # px
                             ...) {
  mnemonics <- read.mnemonics(mnemonic_file)
  translations <- read.mnemonics(translation_file)
  res <- load.track.stats(filename,
                          mnemonics = mnemonics,
                          translations = translations,
                          ...)

  ntracks <- nlevels(res$stats$trackname)
  nlabels <- nlevels(res$stats$label)
  height <- 200 + square.size * ntracks
  width <- 450 + square.size * nlabels

  save.images(dirpath, namebase,
              levelplot.track.stats(res, symmetric = symmetric, ...),
              height = height,
              width = width,
              clobber = clobber)
}

## infilename: stats data.frame tab file
## outfilename: name of mnemonic file to create
make.mnemonic.file <- function(infilename, outfilename, gmtk = FALSE, ...)
{
  res <- load.track.stats(infilename, gmtk = gmtk, ...)
  hierarchical <- res$hierarchical
  stats <- as.stats.array(res$stats)
  stats.norm <- normalize.track.stats(stats)
  mnemonics <- generate.mnemonics(stats.norm, hierarchical = hierarchical, ...)

  con <- file(outfilename, "w")
  write(paste("# mnemonic file generated by Segtools at", date()), con)
  write.table(mnemonics, file = con, quote = FALSE,
              col.names = TRUE, row.names = FALSE, sep = "\t")
  close(con)

  outfilename
}

library(lattice)
library(RColorBrewer)
library(latticeExtra)
library(plyr)
library(reshape)

COLNAMES <- c("group", "component", "offset")
lattice.options(panel.error="stop")

read.aggregation <- function(filename, mnemonics = NULL, ..., 
                             comment.char = "#",
                             check.names = FALSE) {
  if (!file.exists(filename)) {
    stop(paste("Error: could not find aggregation file:", filename))
  }
  data.raw <- read.delim(filename, ..., 
                         comment.char=comment.char, 
                         check.names=check.names)
  colnames(data.raw)[1] <- "group"
  if (!all(colnames(data.raw)[1:3] == COLNAMES)) {
    stop(paste("Error: unsupported aggregation file format.",
               "Expected first three columns to be:",
               paste(COLNAMES, collapse=", ")))
  }

  data <- melt.aggregation(data.raw)

  data$label <- relevel.mnemonics(data$label, mnemonics)

  ## Order components by the order observed in the file
  data$component <- factor(data$component, levels=unique(data$component))

  ## Read metadata and mnemonic-ize it as well
  metadata <- read.metadata(filename, comment.char = comment.char)
  names(metadata) <- map.mnemonics(names(metadata), mnemonics)$labels
  
  list(data = data, metadata = metadata)
}


## Generates pretty scales for the data.
## layout is a 2-element vector: c(num_rows, num_cols) for the xyplot
## num_panels is the number of panels/packets in the trellis
panel.scales <- function(data, layout, num_panels, x.axis = FALSE,
                         significance = FALSE) {
  components <- levels(data$component)
  num_components <- length(components)

  ## Avoid overlapping scales if there is not an even row at the bottom
  remove.extra.scales <- (layout[1] * layout[2] != num_panels) * num_components

  ## Figure out x axis labels (should be same within component)
  at.x <- list()
  limits.x <- list()
  for (cur_component in components) {
    component_subset <- subset(data, component == cur_component)
    min.x <- min(component_subset$offset, na.rm=TRUE)
    max.x <- max(component_subset$offset, na.rm=TRUE)
    if (!is.finite(min.x)) 
      print(component_subset)
    at.x.pretty <- at.pretty(from=min.x, to=max.x, length=5, largest=TRUE)
    at.x <- c(at.x, at.x.pretty)
    ## Cludgy shrink of axes to compensate for automatic trellis expansion
    ## We want the x axis to go to the edge exactly, and axs="i" doesn't
    ## do it.
    limits.x[[length(limits.x) + 1]] <-
      extendrange(c(min.x, max.x), f = -0.05)
  }

  at.x.full <-
    if (x.axis) {
      ## Remove internal axes and space where axes were
      at.x.nonnull.full <- rep(at.x,
                               as.integer((layout[1] - remove.extra.scales) /
                                          num_components))
      c(rep(list(NULL), num_panels - layout[1] + remove.extra.scales),
        at.x.nonnull.full)
    } else {
      NULL
    }

  range.y <- range(data$overlap, na.rm=TRUE)

  ## Extend range for rug
  ngroups <- nlevels(data$group)
  rug.height <-
    if (significance && ngroups > 1)
      diff(range.y) / (1 - get.rug.start(ngroups + 2)) - diff(range.y)
    else
      0
  
  min.y <- min(range.y[1], 0) - rug.height
  max.y <- max(range.y[2], 0)
  
  limits.y <- extendrange(c(min.y, max.y))
  at.y <- unique(round(c(min.y, 0, max.y), digits = 2))
  scales <- list(x = list(relation = "free",
                          tck = c(1, 0),
                          at = at.x.full,
                          rot = 90,
                          limits = limits.x),
                 y = list(alternating = c(2, 0),
                          tck = c(0, 1),
                          limits = limits.y,
                          at = at.y)
                 )

  scales
}

transpose.levels <- function(data.group, dim.length) {
  lev <- levels(data.group)
  nlev <- nlevels(data.group)
  res <- vector(mode = "character", length = nlev)
  num.added <- 0
  for (i in seq(from = 1, length = dim.length)) {
    dest.indices <- seq(from = i, to = nlev, by = dim.length)
    source.indices <- seq(from = num.added + 1, along = dest.indices)
    res[dest.indices] <- lev[source.indices]
    num.added <- num.added + length(dest.indices)
  }
  
  factor(data.group, levels = res)
}

melt.aggregation <- function(data.raw) {
  id.vars <- colnames(data.raw)[1:3]
  data <- melt(data.raw, id.vars = id.vars)
  colnames(data)[(colnames(data) == "variable")] <- "label"
  colnames(data)[(colnames(data) == "value")] <- "count"

  data$group <- factor(data$group)
  data$component <- factor(data$component)
  data$label <- factor(data$label)

  data
}

cast.aggregation <- function(data.df) {
  cast(data.df, group + component + offset ~ label, value = "count")
}

calc.pvals <- function(count, total, random.prob) {
  ## Calculate "significance" of count and total given
  ## current random.prob.
  if (!is.finite(count) || !is.finite(total)) {
    stop("Found non-finite count (", count,
         ") or total (", total,
         ") for label: ", label,
         sep = "")
  }
  
  expected <- total * random.prob
  sep <- abs(expected - count)
  
  signif <- 
    if (total == 0) {
      ## No significance when there are no observed overlaps
      1
    } else if (count > 100 && expected < 10) {
      ## Calculate two-tailed probability 
      ppois(expected - sep, expected) + 
        ppois(expected + sep - 1, expected, lower.tail = FALSE)
    } else {
      ## Binomial is symmetric, so probability is two-tailed with * 2
      if (count < expected) {
        pbinom(count, total, random.prob) * 2
      } else {
        pbinom(count - 1, total, random.prob, lower.tail = FALSE) * 2
      }
    }
  signif <- min(signif, 1)

  signif
}

## Given an aggregation data frame, process the counts by optionally
## normalizing the counts over all labels and by the sizes of the labels
## as well as calculating a significance level for each row.
process.counts <- function(data, label.sizes, pseudocount = 1,
                           normalize = TRUE) {
  if (!is.vector(label.sizes)) stop("Expected vector of label sizes")
  total.size <- sum(label.sizes)
  if (length(total.size) != 1) stop("Error summing label size vector")
  if (!is.finite(total.size)) stop("Unexpected sum of sizes (not finite)")

  ## Ideally, a multinomial test would be applied once for each bin
  ## (testing whether the distribution of overlaps by label is as expected),
  ## but the label-wise binomial seems a decent approximation.
  
  ## Get sum over labels for each component and offset
  labels.sum <- with(data, aggregate(count, list(offset = offset,
                                                 component = component,
                                                 group = group), sum))
  names(labels.sum) <- gsub("^x$", "sum", names(labels.sum))
  
  for (label in levels(data$label)) {
    random.prob <- label.sizes[label] / total.size
##    if (label == "NONE") cat(paste("\n\nNONE:\nrandom.prob:", random.prob))
    cur.rows <- data$label == label
    cur.data <- data[cur.rows,]
    ## Add order row to keep track of order extracted
    ## (so we can reorder for re-insertion)
    cur.data$order <- 1:nrow(cur.data)
    ## Add sum over labels as data frame column
    cur.data <- merge(cur.data, labels.sum)
    ## Reorder merged data back to the order extracted
    cur.data <- cur.data[order(cur.data$order),]
    calc.row.pvals <- function(row) {
      count <- row[1]
      total <- row[2]
      calc.pvals(count, total, random.prob)
    }

##    if (label == "NONE") print(cur.data[1:1,])
    data$pval[cur.rows] <- apply(subset(cur.data, select = c(count, sum)), 1,
                                 calc.row.pvals)
    
    if (normalize) {
      cur.enrichments <- log2((cur.data$count / cur.data$sum + 1) /
                              (random.prob + 1))
      ## Any NaN regions (from 0/0) are masked
      cur.enrichments[is.nan(cur.enrichments)] <- 0
      if (any(cur.enrichments < -1) || any(cur.enrichments > 1)) {
        cat(paste("Enrichment value out of range: [-1, 1]",
                  paste("label:", label),
                  sep = "\n"))
        stop()
      }
##       if (label == "NONE") {
##         cat("\ncur.enrichments:")
##         cat(cur.enrichments[1:3])
##       }
      
      data$count[cur.rows] = cur.enrichments
    }
  }
  data
}

panel.significance <- function(x, y, height, signif, col = plot.line$col,
                               lty = plot.line$lty, lwd = plot.line$lwd, ...) {
  ## signif should be a boolean vector as long as x
  n <- length(x)
  if (n != length(signif)) stop()
  require("grid", quietly = TRUE)
  x.units <- "native"
  y.units <- "npc"
  plot.line <- trellis.par.get("plot.line")
  
  ## Identify contiguous blocks of significance
  starts <- x[c(signif[1], !signif[-n] & signif[-1])]
  ends <- x[c(signif[-n] & !signif[-1], signif[n])]

  gp <- gpar(col = col, lty = 1, lwd = 0, fill = col)
  x0 <- unit(starts - 0.5, x.units)
  #x1 <- unit(ends + 0.5, x.units)
  width <- unit(ends + 0.5 - starts, x.units)
  y0 <- unit(y, y.units)
  height <- unit(height, y.units)
#  grid.segments(x0, y0, x1, y0, gp = gp)
  grid.rect(x0, y0, width, height, just = c("left", "bottom"), gp = gp)
}

get.rug.start <- function(group.number, rug.height = 0.03, rug.spacing = 0.015,
                          rug.offset = 0.025, ...) {
  rug.offset + (rug.spacing + rug.height) * (group.number - 1)
}

panel.aggregation <- function(x, y, ngroups, signif = NULL, groups = NULL,
                              subscripts = NULL, font = NULL, col = NULL,
                              col.line = NULL, pch = NULL,
                              col.high = rgb(.773,.098,.133),
                              col.low = rgb(.224,.365,.655),
                              group.number = NULL, rug.height = 0.03, ...) {
  ## hide 'font' from panel.segments, since it doesn't like having
  ## font and fontface
  panel.refline(h = 0)

  x <- as.numeric(x)
  y <- as.numeric(y)

  if (!is.null(signif)) {
    signif <- as.logical(signif)[subscripts]
    signif[!is.finite(signif)] <- FALSE
  
    if (any(signif)) {
      ## Only shade region for first.
      if (ngroups == 1) {
        fill.col <- "black"
        y.sig <- y
        y.sig[!signif] <- 0
        panel.polygon(cbind(c(min(x), x, max(x)), c(0, y.sig, 0)),
                      col = fill.col)
      } else {
        ##x.sig <- x[signif]
        ##y.sig <- y[signif]
        ##panel.points(x.sig, y.sig, col = fill.col, pch = "*")
        rug.start <- get.rug.start(group.number, rug.height = rug.height, ...)
        panel.significance(x, rug.start, rug.height, signif = signif,
                           col = col.line, ...)
      }
    }
  }

  y.fill <- y
  y.fill[y < 0] <- 0
  panel.polygon(cbind(c(min(x), x, max(x)), c(0, y.fill, 0)),
                col=col.high, border=NA)
  y.fill <- y
  y.fill[y > 0] <- 0
  panel.polygon(cbind(c(min(x), x, max(x)), c(0, y.fill, 0)),
                col=col.low, border=NA)

  ##  panel.xyplot(x, y, groups = groups, subscripts = subscripts, ...)
  #panel.xyplot(x, y, font = font, col = NULL, col.line = NULL,
  #             pch = pch, ...)
}

get.label.sizes <- function(data, metadata) {
  if (length(metadata) == 0) stop("Missing aggregation metadata")
  label.sizes <- NULL
  for (label in levels(data$label)) {
    label.size.raw <- metadata[[as.character(label)]]
    label.size <- as.numeric(label.size.raw)
    if (length(label.size) == 0 || !is.finite(label.size)) {
      stop(paste("Error: encountered invalid size for label:", label,
                 paste("(", label.size.raw,")", sep = "")))
    }
    label.sizes[as.character(label)] <- label.size
  }
  label.sizes
}

calculate.signif <- function(data, fdr.level = 0.05) {
  require("qvalue", quietly = TRUE)
  qobj <- qvalue(p = data$pval, pi0.method = "bootstrap", fdr.level = fdr.level)
  qobj$significant
}

## Plots overlap vs position for each label
##   data: a data frame with fields: count, offset, label
##   spacers should be a vector of indices, where a spacer will be placed after
##     that component (e.g. c(1, 3) will place spacers after the first and third
##     components
xyplot.aggregation <- function(agg.data = NULL,
    data = agg.data$data,
    x = overlap ~ offset | component * label,
    metadata = agg.data$metadata,
    spacers = metadata$spacers,
    normalize = TRUE,
    significance = FALSE,
    x.axis = FALSE,  # Show x axis
    fdr.level = 0.05,
    text.cex = 1,
    spacing.x = 0.4,
    spacing.y = 0.4,
    ngroups = nlevels(data$group),      
    panel = panel.aggregation,
    par.settings = list(add.text = list(cex = text.cex),
                        layout.heights = list(axis.panel = axis.panel,
                                              strip = strips.heights)),
    auto.key = if (ngroups < 2) FALSE
               else list(points = FALSE, lines = TRUE),
    strip = strip.custom(horizontal = FALSE),
    strip.height = 11,
    par.strip.text = list(cex = 0.85),
    xlab = NULL,
    ylab = if (normalize)
              expression(paste("Enrichment: ",
                  log[2], group("[", (f[plain(obs)] + 1)/(f[plain(rand)] + 1),
                                 "]")))
           else "Count",
    sub = if (significance) {
            substitute(
              expression(paste(FORMAT, " regions are significant with ",
                               italic(q) <= FDR)),
              list(FORMAT = if (ngroups > 1) "Rug" else "Black",
                   FDR = fdr.level))
          } else {
            NULL
          },
    ...)
{
  label.sizes <- get.label.sizes(data, metadata)
  ## Normalize and/or calculate significance if metadata exists
  data <- process.counts(data, label.sizes, normalize = normalize)
  if (significance) {
    data$signif <- calculate.signif(data, fdr.level)
  }
  
  names(data) <- gsub("^count$", "overlap", names(data))
  data$overlap[!is.finite(data$overlap)] <- 0

  ## Determine panel layout
  num_levels <- nlevels(data$label)
  num_components <- nlevels(data$component)
  num_rows <- num_components
  num_cols <- num_levels
  num_panels <- num_rows * num_cols

  ## Rework layout to optimize organization
  while (num_cols > num_rows) {
    num_cols <- num_cols / 2
    num_rows <- num_rows * 2
  }
  num_cols <- ceiling(num_cols)
  layout <- c(num_rows, num_cols)

  ## Reorder labels so they are in order downward in panels
  data$label <- transpose.levels(data$label, num_rows / num_components)

  ## Separate distinct groups
  spaces.x <- rep(0, num_components - 1)
  if (!is.null(spacers) && length(spacers) > 0) {
    spacers <- as.integer(spacers)
    if (any(spacers < 1 | spacers >= num_components)) {
      stop("Spacer vector should only contain values in the range [1, ",
           num_components - 1,
           "] since there are ", num_components, " components")
    }
    spaces.x[spacers] <- spacing.x
  }
  between <- list(x = c(spaces.x, spacing.x), 
                  y = spacing.y)

  scales <- panel.scales(data, layout, num_panels, x.axis = x.axis,
                         significance = significance)
  axis.panel <- rep(c(0, 1), c(num_cols - 1, 1))

  ## Make top strips longer
  strips.heights <- rep(c(strip.height, 0), c(1, num_cols - 1))

  args <- list(x, data = data, type = "l", groups = quote(group),
               auto.key = auto.key, as.table = TRUE, strip = strip,
               xlab = xlab, ylab = ylab, sub = sub,
               signif = data$signif, ngroups = ngroups,
               panel = "panel.superpose", panel.groups = panel,
               par.strip.text = par.strip.text,
               ...)

  trellis.raw <- do.call(xyplot, args)

  trellis <- useOuterStrips(trellis.raw, strip = strip)

  update(trellis, layout = layout, between = between, scales = scales,
         par.settings = par.settings)
}

plot.aggregation <- function(filename, mnemonics = NULL, ...,
                             comment.char = "#") {
  data <- read.aggregation(filename, mnemonics = mnemonics,
                           comment.char = comment.char)

  xyplot.aggregation(data, ...)
}

save.aggregation <- function(dirpath, namebase, tabfilename,
                             mnemonic_file = NULL,
                             clobber = FALSE,
                             panel.size = 200,  # px
                             margin.size = 200,  #px
                             comment.char = "#",
                             ...) {
  mnemonics <- read.mnemonics(mnemonic_file)
  data <- read.aggregation(tabfilename, mnemonics = mnemonics,
                           comment.char = comment.char)
  
  image.size <- margin.size +
    panel.size * ceiling(sqrt(nlevels(data$data$label) / 2))
  save.images(dirpath, namebase,
              xyplot.aggregation(data, ...),
              width = image.size,
              height = image.size,
              clobber = clobber)
}

save.gene.aggregations <- function(dirpath, namebase1, namebase2, tabfilename,
                                   mnemonic_file = NULL,
                                   clobber = FALSE,
                                   panel.size = 200,  # px
                                   margin.size = 200,  #px
                                   width = image.size,
                                   height = image.size,
                                   width.pdf = image.size / 72,
                                   height.pdf = image.size / 72,
                                   comment.char = "#",
                                   ...) {
  mnemonics <- read.mnemonics(mnemonic_file)
  data <- read.aggregation(tabfilename, mnemonics = mnemonics,
                           comment.char = comment.char)

  image.size <- margin.size +
    panel.size * ceiling(sqrt(nlevels(data$data$label) / 2))
  ngroup1 <- as.integer(data$metadata[["spacers"]])
  if (ngroup1 <= 0 || ngroup1 >= nlevels(data$data$component))
    stop("Invalid metadata for gene aggregation plots")

  plot.one <- function(namebase, components.sub, ...) {
    data.sub <- subset(data$data, component %in% components.sub, drop = TRUE)
    data.sub$component <- factor(data.sub$component, levels=components.sub)
    save.images(dirpath, namebase,
                xyplot.aggregation(data = data.sub, metadata = data$metadata,
                                   spacers = NULL, ...),
                width = width,
                height = height,
                width.pdf = width.pdf,
                height.pdf = height.pdf,
                clobber = clobber)
  }

  components <- levels(data$data$component)
  ## Transcriptional components
  plot.one(namebase1, head(components, ngroup1), ...)
  ## Translational components (plus flankings again)
  plot.one(namebase2, c(components[1],
                        tail(components, -ngroup1),
                        components[ngroup1]), ...)
}

#!/usr/bin/env bash

## build.sh: build R package

## $Revision$
## Copyright 2012 Michael M. Hoffman <mmh1@uw.edu>

set -o nounset -o pipefail -o errexit

if [[ $# != 0 || "${1:-}" == "--help" || "${1:-}" == "-h" ]]; then
    echo usage: "$0"
    exit 2
fi

R CMD build segtools
